# -*- coding: utf-8 -*-
import sys
import os
import MainWindowGUI
import Calcul
import Vypocet_GUI
import About_madet
import random
from PyQt4 import QtCore, QtGui
Rad = 0


class Main_Window(QtGui.QMainWindow, MainWindowGUI.Ui_MainWindow):    
  def __init__(self):
      QtGui.QMainWindow.__init__(self)
      self.setupUi(self)
      self.icon = QtGui.QIcon()
      self.icon.addPixmap(QtGui.QPixmap("./madet_logo.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
      
      


  
  def vykresli(self):
    "vykresli matici"
    global Rad
    self.btnReset.setEnabled(True)
    self.btnUkazatVypocet.setEnabled(True)
    if Rad != 0:#poprvé nic nemazat
      self.vymazani()
    self.spinboxy()


  def spinboxy(self):
    "vykresli spinboxy"
    global Rad
    self.spbMatice = []
    Rad = self.spbRad.value()
    for i in xrange(Rad):
      self.spbMatice.append([])
      for y in xrange(Rad):
	  self.spbMatice[i].append(QtGui.QSpinBox(self.frameMatice))
	  self.gridLayout.addWidget(self.spbMatice[i][y],i,y,1,1)
	  
	  self.spbMatice[i][y].setMinimum(-999)
	  self.spbMatice[i][y].setMaximum(999)
	  #!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!SMAZAT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	  self.spbMatice[i][y].setValue(random.randint(0, 10))#náhodné hodnoty abych to nemusel pořád zadávat

  #Vymazani spinboxu
  def vymazani(self):
    "vymaze spinboxy"
    
    for a in xrange(len(self.spbMatice)):
      for b in xrange(len(self.spbMatice[a])):
	self.spbMatice[a][b].setParent(None)
	self.gridLayout.removeWidget(self.spbMatice[a][b])
	
    del self.spbMatice
    
  def reset(self):
    "maže hodnoty matice"
    stupen = len(self.spbMatice)
    for i in xrange(stupen):
      for y in xrange(stupen):
	self.spbMatice[i][y].setValue(0)

  def Nacti_matici(self):
    "Načítení determinantu ze spinBoxu"
    self.matic = []
    for i in xrange(len(self.spbMatice)):#len pocet radku matice
      self.matic.append([])  #pridava radek
      for y in xrange(len(self.spbMatice[i])):
	self.matic[i].append(int(self.spbMatice[i][y].value()))
    return self.matic

  def Zobraz_Vysledek(self):
    "zobrazí výsledek na lcd display"
    self.matice=self.Nacti_matici()
    self.DET=Calcul.determinant()
    self.lcdVysledek.display(self.DET.vypocet(self.matice, len(self.matice)))
    
    
  def Vypocet(self):
    self.VPC_GUI=Vypocet_GUI.Vypocet_GUI()
    self.determinant=self.Nacti_matici()
    self.VPC_GUI.Vykresleni(self.determinant)
    self.VPC_GUI.setWindowModality(2)
    self.VPC_GUI.show()
    
  def About_Madet(self):
    "otevře about dialog"
    self.About_Madet_GUI = About_madet.About_madet()
    self.About_Madet_GUI.setWindowModality(2)
    self.About_Madet_GUI.show()

    
  def About_Qt(self):
    "otevře about QT dialog "
    QtGui.QMessageBox.aboutQt(self)
    
  def Napoveda(self):
    "otevření nápovědy"
    os.system("assistant -collectionFile doc/madet.qhc")
    
    
