# -*- coding: utf-8 -*-

from PyQt4 import QtCore, QtGui
import Vypocet_GUI_UI 
import Calcul

class Vypocet_GUI(QtGui.QDialog, Vypocet_GUI_UI.Ui_Vypocet_GUI_Dialog):
  def __init__(self):
    QtGui.QDialog.__init__(self)
    self.setupUi(self)
    self.krok = 0
    self.vysledek = 0

    QtCore.QObject.connect(self.btnNext, QtCore.SIGNAL("clicked()"), self.Next)
  
  def Vykresleni(self, matice):
    self.lblMaticeV = []
    self.MATRIX = matice
    for x in xrange(len(matice)):
      self.lblMaticeV.append([])
      for y in xrange(len(matice)):
	self.lblMaticeV[x].append(QtGui.QLabel(self.frmVrchni))
	#self.lblMaticeV[x][y].setObjectName("lblMaticeV[",x,"][",y,"]")
	self.gridLOVrchni.addWidget(self.lblMaticeV[x][y], x, y, 1, 1)
	self.lblMaticeV[x][y].setText( str(matice[x][y]))
	
	
  def Next(self):
    "Ukáže názorný výpočet"
    if len(self.MATRIX) == 2:   

      if self.krok == 0:
	self.vysledek = self.MATRIX[0][0]*self.MATRIX[1][1]
	
	self.lblPrvni = QtGui.QLabel(self.frmSpodni)
	self.lblPrvni.setObjectName("lblPrvni")
	self.gridLOSpodni.addWidget(self.lblPrvni, 0, 0, 1, 1)
	
	self.lblDruhy = QtGui.QLabel(self.frmSpodni)
	self.lblDruhy.setObjectName("lblDruhy")
	self.gridLOSpodni.addWidget(self.lblDruhy, 0, 1, 1, 1)
	
	self.lblDruhy.setText("<p style=\"font-weight:600;font-size:20pt;background:red;\">" + str(self.MATRIX[0][0]) + "*" + str(self.MATRIX[1][1]))
	#Vybarvi
	self.lblMaticeV[0][0].setText("<p style=\"font-weight:600;background:red;\">" + self.lblMaticeV[0][0].text())
	self.lblMaticeV[1][1].setText("<p style=\"font-weight:600;background:red;\">" + self.lblMaticeV[1][1].text())
	
	
	self.krok += 1
	
      elif self.krok == 1:
	#self.lblPrvni.setText(str(self.MATRIX[0][0]*self.MATRIX[1][1]) + "-")
	self.lblPrvni.setText(self.lblDruhy.text())
	self.lblDruhy.setText("<p style=\"font-weight:600;font-size:20pt;background:red;\">" + str(self.MATRIX[0][1]) + "*" + str(self.MATRIX[1][0]))
	self.vysledek -= (self.MATRIX[0][1] * self.MATRIX[1][0])
	#Odbarvi a vybarvi
	self.lblMaticeV[0][0].setText(str(self.MATRIX[0][0]))
	self.lblMaticeV[1][1].setText(str(self.MATRIX[1][1]))
	self.lblMaticeV[0][1].setText("<p style=\"font-weight:600;background:red;\">" + self.lblMaticeV[0][1].text())
	self.lblMaticeV[1][0].setText("<p style=\"font-weight:600;background:red;\">" + self.lblMaticeV[1][0].text())
	
	
	self.krok += 1
	
      else:
	self.lblPrvni.setText(self.lblPrvni.text() + str(self.MATRIX[0][1]*self.MATRIX[1][0]) + "=")
	
	self.lblDruhy.setText("<p style=\"font-weight:600;font-size:20pt;background:red;\">" + str(self.vysledek))
	self.btnNext.setEnabled(False)
	#Odbarvi
	self.lblMaticeV[0][1].setText(str(self.MATRIX[0][1]))
	self.lblMaticeV[1][0].setText(str(self.MATRIX[1][0]))
	
	
      
    else:
      if self.krok < len(self.MATRIX):
	self.NazorVypoc = MeziVypoc(self.MATRIX, self.krok)
	self.Subdet = self.NazorVypoc.subdeterminant()
	self.pulka = (len(self.MATRIX)-1)/2
	
	if self.krok != 0:
	  
	  self.lblVypocet.setText(self.lblVypocet.text() + str(self.NazorVypoc.vypocetmezidet()) + " + ")
	  self.vysledek += self.NazorVypoc.vypocetmezidet()
	  
	
	else:
	  self.lblVypocet = QtGui.QLabel(self.frmSpodni)
	  self.lblVypocet.setObjectName("lblVypocet")
	  self.gridLOSpodni.addWidget(self.lblVypocet, self.pulka, 0, 1, 1)
	  
	  self.lblKofaktor = QtGui.QLabel(self.frmSpodni)
	  self.lblKofaktor.setObjectName("lblKofaktor")
	  self.gridLOSpodni.addWidget(self.lblKofaktor, self.pulka, 1, 1, 1)
	  
	  #Vytvoří subdeterminant
	  self.lblSubdeterminat = []
	  for x in xrange(len(self.MATRIX)-1):
	    self.lblSubdeterminat.append([])
	    for y in xrange(len(self.MATRIX)-1):
	      self.lblSubdeterminat[x].append(QtGui.QLabel(self.frmSpodni))
	      self.gridLOSpodni.addWidget(self.lblSubdeterminat[x][y], x, y+2, 1, 1)
	      
	
	
	self.lblKofaktor.setText("<p style=\"font-weight:600;font-size:20pt;background:red;\">(-1)<span style=\"vertical-align:super\">(1+" + str(self.krok+1) + ")</span> * " + str(self.MATRIX[0][self.krok])+ " *</p>")
	
	#Naplnění subdeterminantu
	
	for x in xrange(len(self.Subdet)):
	  for y in xrange(len(self.Subdet)):
	    self.lblSubdeterminat[x][y].setText("<p style=\"font-weight:600;background:yellow;\">" + str(self.Subdet[x][y]))
	    
	  
	self.color()
	self.krok += 1
      else: #self.krok == len(self.MATRIX):
	
	#odstranuje barvu z lblMaticeV
	for x in xrange(1, len(self.MATRIX)):
	  for y in xrange(len(self.MATRIX)):
	    self.lblMaticeV[x][y].setText(str(self.MATRIX[x][y]))
	self.lblMaticeV[0][len(self.MATRIX)-1].setText(str(self.MATRIX[0][len(self.MATRIX)-1]))
	    
	
	#Smaže lblSubdeterminat
	for a in xrange(len(self.lblSubdeterminat)):
	  for b in xrange(len(self.lblSubdeterminat[a])):
	    self.lblSubdeterminat[a][b].setParent(None)
	    self.gridLOSpodni.removeWidget(self.lblSubdeterminat[a][b])
	del self.lblSubdeterminat
	
	self.NazorVypoc = MeziVypoc(self.MATRIX, self.krok)
	self.lblVypocet.setText(self.lblVypocet.text() + str(self.NazorVypoc.vypocetmezidet()) + " = ")
	
	
	self.vysledek += self.NazorVypoc.vypocetmezidet()
	
	self.lblKofaktor.setText("<p style=\"font-weight:600;background:red;font-size:20pt;\">" + str(self.vysledek))
	
	#Vypnutí next
	self.btnNext.setEnabled(False)
	self.krok += 1
    
      
      
      
    
  def color(self):
    "Zvýraznění při názorném výpočtu"
    if self.krok == 0:
      self.lblMaticeV[0][self.krok].setText("<p style=\"font-weight:600;background:red;\">" + self.lblMaticeV[0][self.krok].text())
      for x in xrange(1, len(self.MATRIX)):
	for y in xrange(1, len(self.MATRIX)):
	  self.lblMaticeV[x][y].setText("<p style=\"font-weight:600;background:yellow;\">" + self.lblMaticeV[x][y].text() )
    else:
      self.lblMaticeV[0][self.krok].setText("<p style=\"font-weight:600;background:red;\">" + self.lblMaticeV[0][self.krok].text())
      self.lblMaticeV[0][self.krok-1].setText(str(self.MATRIX[0][self.krok-1]))
      for x in xrange(1, len(self.MATRIX)):
	self.lblMaticeV[x][self.krok-1].setText("<p style=\"font-weight:600;background:yellow;\">" + self.lblMaticeV[x][self.krok-1].text() )
	self.lblMaticeV[x][self.krok].setText(str(self.MATRIX[x][self.krok]))
	
    
  
class MeziVypoc(Calcul.determinant):
  def __init__(self, MATRIX, KROK):
    self.MATRIX = MATRIX
    self.KROK = KROK
    self.Stupen= len(self.MATRIX)-1
    
  def subdeterminant(self):
    return self.subdeter(self.MATRIX, self.KROK)
    
  def vypocetmezidet(self):
    
    self.SUBDET = MeziVypoc(self.MATRIX, self.KROK-1).subdeterminant()
    self.kk= self.KROK -1
    
    self.VYS = (-1)** self.kk * self.MATRIX[0][self.kk] * self.vypocet(self.SUBDET, len(self.SUBDET))
    return self.VYS
    
  